#include "game.hpp"
#include "texture.hpp"

namespace cloonel {
	namespace {
	} //unnamed namespace

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	Game::Game (SDLMain* parSdlMain) :
		GameBase(parSdlMain),
		m_character(nullptr),
		m_posx(0.0f),
		m_posy(0.0f)
	{
	}

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	Game::~Game() noexcept {
	}

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	void Game::Prepare() {
		m_character = LoadTexture("resources/graphics/duck.bmp");
	}

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	void Game::Destroy() noexcept {
		m_character = std::move(std::unique_ptr<Texture>(nullptr));
	}

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	void Game::OnRender() {
		const int posx = static_cast<int>(m_posx + 0.5f);
		const int posy = static_cast<int>(m_posy + 0.5f);
		m_character->Render(posx, posy);
	}

	///------------------------------------------------------------------------
	///------------------------------------------------------------------------
	void Game::OnUpdate (float parDelta) {
		m_posx += parDelta * 15.0f;
		m_posy += parDelta * 22.8f;
	}
} //namespace cloonel
