#include "CloonelJumpConfig.h"
#include "sdlmain.hpp"
#include "game.hpp"
#include <iostream>
#include <stdexcept>
#include <ciso646>

namespace {
	///-------------------------------------------------------------------------
	///-------------------------------------------------------------------------
	void RunMainLoop (cloonel::Game& parGame) {
		float totalElapsed = 0.0f;
		do {
			const float delta = parGame.Exec();
			totalElapsed += delta;
		} while (not parGame.WantsToQuit());
	}
} //unnamed namespace

///----------------------------------------------------------------------------
///following http://twinklebeardev.blogspot.co.uk/2012/07/lesson-1-hello-world.html
///----------------------------------------------------------------------------
int main() {
	std::cout << GameName << " v" << GameVersionMajor << "." << GameVersionMinor << std::endl;

	cloonel::SDLMain sdlmain(GameName, DEF_WIN_WIDTH, DEF_WIN_HEIGHT);
	try {
		sdlmain.Init();
	}
	catch (const std::runtime_error& e) {
		std::cerr << "Error during SDL2 initialization:\n";
		std::cerr << e.what() << std::endl;
	}

	cloonel::Game game(&sdlmain);
	game.Prepare();
	RunMainLoop(game);

	std::cout << "Quitting now" << std::endl;
	return 0;
}
